<?php
/**
*
* @package index.php
* @package cBB Blog Installer
* @version $Id: index.php,v1.0.1 10/06/2013 $
*
* @copyright (c) 2013 CaniDev
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
define('IN_PHPBB', true);
define('IN_INSTALL', true);
$phpbb_root_path = (defined('PHPBB_ROOT_PATH')) ? PHPBB_ROOT_PATH : './../../';
$phpEx = substr(strrchr(__FILE__, '.'), 1);

/* Include installer */
include('./includes/installer.' . $phpEx);

// Start session management
$user->session_begin();
$auth->acl($user->data);
$user->setup();

// Initialize installer
$installer = create_installer();
$installer->setup(array('mods/blog/installer'));

$installer->mod_title		= 'cBB Blog';
$installer->new_version		= '1.0.1';
$installer->required_phpbb	= '3.0.8';

// Main files
$installer->assign_files(array(
	'constants'			=> $phpbb_root_path . 'blog/includes/constants.' . $phpEx,
	'schema_install'	=> './schemas/schema_install.' . $phpEx,
	'schema_update'		=> './schemas/schema_update.' . $phpEx,
));

/* Values to obtain installed version */
$installer->version_key		= 'blog_version';

/* Global MOD ID in the canidev web */
$installer->mod_id = 'cbb-blog';

/* Have documentation? */
$installer->load_doc = true;

/* Define installer logo */
$config['force_server_vars'] = true;
$installer->logo = generate_board_url() . '/blog/images/cbb-blog-logo.png';

/* Initialize */
$installer->load();

?>
