<?php
/*
*
* @name schema_update.php
* @package cBB Blog Installer
* @version $Id: schema_update.php,v1.0.1 10/06/2013 $
*
* @copyright (c) 2013 CaniDev
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

if(!defined('IN_PHPBB') || !defined('IN_INSTALL'))
{
	exit;
}

switch($current_version)
{
	// 1.0.0 to 1.0.1
	case '1.0.0-beta':
		$this->umil->table_add(BLOG_SOURCES_TABLE, $this->schema['table_add'][BLOG_SOURCES_TABLE]);
		
		$this->umil->table_column_add(array(
			array(BLOG_CATS_TABLE,	'cat_url', 			array('VCHAR', '')),
			array(BLOG_POSTS_TABLE, 'post_url', 		array('VCHAR', '')),
			array(USERS_TABLE, 		'user_blog_posts', 	array('UINT:8', 0)),
		));
		
		$this->umil->config_add(array(
			array('blog_cmnt_maxlength', 600),
			array('blog_cmnt_order', 'DESC'),
			array('blog_cron_lock', 0, true),
			array('blog_index_stats', true),
			array('blog_num_posts', 0),
			array('blog_pagination', 'full'),
			array('blog_related_posts', 0),
			array('blog_seo_enabled', false),
		));
		
		$this->umil->module_add('acp', 'ACP_CAT_BLOG', array(
			'module_basename'	=> 'blog',
			'modes'				=> array('tools'),
		));
		
		$this->umil->permission_add(array(
			array('m_blog_forum', true),
			array('u_blog_forum', true),
		));
		
		$this->umil->permission_set(array(
			array('ROLE_MOD_FULL', 'm_blog_forum'),
			array('ROLE_USER_FULL', 'u_blog_forum'),
		));
		
		sync_blog_stats();
		sync_blog_seo();

	// no break;
	
	// latest version
	case '1.0.1':
	break;
	
	default:
		$update_error = true;
	break;
}

function sync_blog_seo()
{
	global $db, $blog_hook, $phpEx;

	if(!class_exists('blog_seo'))
	{
		include($blog_hook->root_path . 'includes/functions_seo.' . $phpEx);
	}
	
	$blog_seo = new blog_seo();

	$sql = 'SELECT post_id, post_title
		FROM ' . BLOG_POSTS_TABLE;
	$result = $db->sql_query($sql);
	while($row = $db->sql_fetchrow($result))
	{
		$post_url = $blog_seo->format_url($row['post_title']);
		
		$sql = 'UPDATE ' . BLOG_POSTS_TABLE . "
			SET post_url = '" . $db->sql_escape($post_url) . "'
			WHERE post_id = " . $row['post_id'];
		$db->sql_query($sql);
	}
	$db->sql_freeresult($result);
	
	$sql = 'SELECT cat_id, cat_name
		FROM ' . BLOG_CATS_TABLE;
	$result = $db->sql_query($sql);
	while($row = $db->sql_fetchrow($result))
	{
		$cat_url = $blog_seo->format_url($row['cat_name']);
		
		$sql = 'UPDATE ' . BLOG_CATS_TABLE . "
			SET cat_url = '" . $db->sql_escape($cat_url) . "'
			WHERE cat_id = " . $row['cat_id'];
		$db->sql_query($sql);
	}
	$db->sql_freeresult($result);
}

?>
