<?php
/*
*
* @name mcp.php
* @package cBB Blog
* @version $Id: mcp.php,v1.0.1 10/06/2013 $
*
* @copyright (c) 2013 CaniDev
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*/

/**
* @ignore
*/
define('IN_PHPBB', true);
define('IN_BLOG', true);
$phpbb_root_path = (defined('PHPBB_ROOT_PATH')) ? PHPBB_ROOT_PATH : '../';
$phpEx = substr(strrchr(__FILE__, '.'), 1);
include($phpbb_root_path . 'common.' . $phpEx);

// Start session management
$user->session_begin();
$auth->acl($user->data);
$user->setup('mods/blog/mcp');

if(empty($blog_hook->enabled))
{
	redirect(append_sid($phpbb_root_path . "index.$phpEx"));
}

if(!$auth->acl_gets(array('m_blog_delete', 'm_blog_approve', 'm_blog_cmnt_delete')))
{
	trigger_error('NOT_AUTHORISED');
}

$modules = array(
	'queue'		=> 	array(
		'lang'		=> 'MCP_QUEUE',
		'modules'	=> array(
			'unapproved_posts'	=> array('UNAPPROVED_POSTS',	array('m_blog_delete', 'm_blog_approve')),
			'spam_comments'		=> array('SPAM_COMMENTS', 		array('m_blog_cmnt_delete')),
		),
	),
	'posts'		=> 	array(
		'lang'		=> 'MCP_POSTS',
		'modules'	=> array(
			'post_list'		=> array('POST_LIST', array('m_blog_edit', 'm_blog_delete')),
		),
	),
);

$mode		= request_var('m', 'queue');
$module_id	= request_var('i', '');
$cat_id		= request_var('c', 0);

$action = request_var('action', '');
$action_ary = request_var('action', array('' => 0));

if (sizeof($action_ary))
{
	list($action, ) = each($action_ary);
}
unset($action_ary);

if(!isset($modules[$mode]) || ($module_id && !isset($modules[$mode]['modules'][$module_id])))
{
	trigger_error('NO_MODE');
}

// Find the first module avaliable
if(!$module_id)
{
	$module_id = get_module_id($mode, $modules);
}

$module_class = 'mcp_' . $mode;
include($blog_hook->root_path . 'includes/mcp/' . $module_class . '.' . $phpEx);
$module = new $module_class();

$module->main($mode, $module_id);

// Build Tabs
foreach($modules as $tab_id => $tab_data)
{
	$template->assign_block_vars('tab', array(
		'S_TITLE'		=> $user->lang($tab_data['lang']),
		'S_SELECTED'	=> ($tab_id == $mode) ? true : false,

		'U_TITLE'		=> blog::append_sid('mcp', false, array('m' => $tab_id)),
	));
	
	foreach($tab_data['modules'] as $id => $module_data)
	{
		if($module_data[1] !== false)
		{
			if(!$auth->acl_gets($module_data[1]))
			{
				continue;
			}
		}
		$template->assign_block_vars('tab.module', array(
			'S_TITLE'		=> $user->lang($module_data[0]),
			'S_SELECTED'	=> ($id == $module_id) ? true : false,

			'U_TITLE'		=> blog::append_sid('mcp', false, array('m' => $mode, 'i' => $id)),
		));
	}
}

$template->assign_vars(array(
	'U_MCP_ACTION'	=> blog::append_sid('mcp', false, array(
		'm'		=> $mode,
		'i'		=> $module_id,
		'c'		=> $cat_id,
	))
));

// Output page
$page_title = (isset($user->lang[$module->page_title]) ? $user->lang[$module->page_title] : $module->page_title);

page_header($user->lang['MCP'] . ' &bull; ' . $page_title);

blog::build_navbar(false, array(
	'MCP'	=> array('mcp')
));

$template->set_filenames(array(
	'body' => 'blog/' . $module->tpl_name . '.html'
));

page_footer(false);

function get_module_id($mode, $modules)
{
	global $auth;

	foreach($modules[$mode]['modules'] as $id => $data)
	{
		if($data[1] === false || $auth->acl_gets($data[1]))
		{
			return $id;
		}
	}
	
	trigger_error('NO_MODE');
}

?>