<?php
/*
*
* @name search.php
* @package cBB Blog
* @version $Id: search.php,v1.0.1 10/06/2013 $
*
* @copyright (c) 2013 CaniDev
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*/

/**
* @ignore
*/
define('IN_PHPBB', true);
define('IN_BLOG', true);
$phpbb_root_path = (defined('PHPBB_ROOT_PATH')) ? PHPBB_ROOT_PATH : '../';
$phpEx = substr(strrchr(__FILE__, '.'), 1);
include($phpbb_root_path . 'common.' . $phpEx);

// Start session management
$user->session_begin();
$auth->acl($user->data);
$user->setup();

if(empty($blog_hook->enabled))
{
	redirect(append_sid($phpbb_root_path . "index.$phpEx"));
}

$mode		= request_var('mode', '');
$tag 		= request_var('tag', '', true);
$keywords	= utf8_normalize_nfc(request_var('keywords', '', true));
$terms		= request_var('terms', 'all');
$sf			= request_var('sf', 'all');
$start		= request_var('start', 0);
$author_id	= request_var('author_id', 0);

$keywords_ary = $post_rows = $error = array();
$bbcode_bitfield = '';
$total_posts = 0;

switch($mode)
{
	case 'user':
		include($phpbb_root_path . 'includes/functions_display.' . $phpEx);
		
		$user->add_lang('memberlist');

		$form		= request_var('form', '');
		$field		= request_var('field', '');
		$first_char = request_var('fchar', '');
	
		$first_characters = array('' => $user->lang['CHAR_ALL']);

		for($i = 97; $i < 123; $i++)
		{
			$first_characters[chr($i)] = chr($i - 32);
		}

		foreach($first_characters as $char => $desc)
		{
			$template->assign_block_vars('first_char', array(
				'DESC'			=> $desc,
				'VALUE'			=> $char,
				'S_SELECTED'	=> ($first_char == $char) ? true : false,
				'U_SORT'		=> blog::append_sid('search', false, array(
					'mode'	=> 'user',
					'fchar'	=> $char
				))
			));
		}
		
		$sql_where = ($first_char) ? 'AND username_clean ' . $db->sql_like_expression($db->any_char . $first_char . $db->any_char) : '';
		
		$sql = 'SELECT *
			FROM ' . USERS_TABLE . '
			WHERE user_type <> ' . USER_IGNORE . "
			$sql_where
			ORDER BY username_clean ASC";
		$result = $db->sql_query($sql, $config['topics_per_page']);
		while($row = $db->sql_fetchrow($result))
		{
			$rank_title = $rank_img = '';
			get_user_rank($row['user_rank'], (($row['user_id'] == ANONYMOUS) ? false : $row['user_posts']), $rank_title, $rank_img, $rank_img_src);

			if($blog_hook->domain)
			{
				$rank_img = str_replace('src="' . $phpbb_root_path, 'src="' . generate_board_url() . '/', $rank_img);
			}
			
			$template->assign_block_vars('userrow', array(
				'JOINED'		=> $user->format_date($row['user_regdate']),
				'LOCATION'		=> $row['user_from'],
				'POSTS'			=> $row['user_posts'],
				'RANK_IMG'		=> $rank_img,
				'RANK_TITLE'	=> $rank_title,
				'USERNAME'		=> $row['username'],
				'USERNAME_FULL'	=> get_username_string('full', $row['user_id'], $row['username'], $row['user_colour']),
				'VISITED'		=> (empty($row['user_lastvisit'])) ? ' - ' : $user->format_date($row['user_lastvisit']),
				'WWW'			=> $row['user_website'],
			));
		}
		$db->sql_freeresult($result);

		$pagination_url = blog::append_sid('search', false, array(
			'mode'	=> 'user',
			'fchar'	=> $char
		));
		
		$template->assign_vars(array(
			'PAGINATION'	=> generate_pagination($pagination_url, $config['num_users'], $config['topics_per_page'], $start),
			'PAGE_NUMBER'	=> on_page($config['num_users'], $config['topics_per_page'], $start),
			'TOTAL_USERS'	=> ($config['num_users'] == 1) ? $user->lang['LIST_USER'] : sprintf($user->lang['LIST_USERS'], $config['num_users']),

			'S_FIELD_NAME'		=> $field,
			'S_FORM_NAME'		=> $form,
			'S_VIEWONLINE'		=> $auth->acl_get('u_viewonline'),
		));
		
		page_header($user->lang['MEMBERLIST']);

		$template->set_filenames(array(
			'body' => 'blog/search_user.html'
		));

		page_footer();
	break;
}

$sql_ary = array(
	'SELECT'	=> 'p.*, u.username, u.user_colour',
	'FROM'		=> array(BLOG_POSTS_TABLE => 'p'),
	
	'LEFT_JOIN'	=> array(
		array(
			'FROM'	=> array(USERS_TABLE => 'u'),
			'ON'	=> 'u.user_id = p.poster_id'
		)
	),
	
	'WHERE'		=> 'p.post_time < ' . time() . (!$auth->acl_get('m_blog_approve') ? ' AND p.post_approved = 1' : ''),
	'ORDER_BY'	=> 'post_title ASC',
);

if($tag || $keywords || $author_id)
{
	if($author_id)
	{
		$sql = 'SELECT username
			FROM ' . USERS_TABLE . "
			WHERE user_id = $author_id
			AND user_type <> " . USER_IGNORE;
		$result = $db->sql_query($sql);
		$user_data = $db->sql_fetchrow($result);
		$db->sql_freeresult($result);

		if(!$user_data)
		{
			redirect(blog::append_sid('search'));
		}
		
		$sql_ary['WHERE'] .= (($sql_ary['WHERE']) ? ' AND ' : '') . "p.poster_id = $author_id";
	}
	else if($tag)
	{
		$post_ids = array();

		$sql = 'SELECT post_id
			FROM ' . BLOG_TAGS_TABLE . "
			WHERE LOWER(tag_name) = '" . $db->sql_escape($tag) . "'";
		$result = $db->sql_query($sql);
		while($row = $db->sql_fetchrow($result))
		{
			$post_ids[] = $row['post_id'];
		}
		$db->sql_freeresult($result);
		
		if(sizeof($post_ids))
		{
			$sql_ary['WHERE'] .= (($sql_ary['WHERE']) ? ' AND ' : '') . $db->sql_in_set('post_id', $post_ids);
		}
	}
	else if($keywords)
	{
		$sql_where = array();

		if($terms == 'all')
		{
			$keywords_ary = array($keywords);
		}
		else
		{
			$keywords_ary = explode(' ', $keywords);
		}
		
		foreach($keywords_ary as $key_id => $keyword)
		{
			$keyword = trim($keyword);
			
			if(utf8_strlen($keyword) < 3)
			{
				unset($keywords_ary[$key_id]);
				continue;
			}
			
			$keywords_ary[$key_id] = $keyword;
		}
		
		if(!sizeof($keywords_ary))
		{
			$error[] = $user->lang['KEYWORDS_ERROR'];
		}
		
		foreach($keywords_ary as $keyword)
		{
			$like_exp = $db->sql_like_expression($db->any_char . strtolower(trim($keyword)) . $db->any_char);

			if($sf == 'all' || $sf == 'titleonly')
			{
				$sql_where[] = "LOWER(post_title) $like_exp";
			}
			
			if($sf == 'all' || $sf == 'msgonly')
			{
				$sql_where[] = "LOWER(post_text) $like_exp";
			}
		}
		
		if(sizeof($sql_where))
		{
			$sql_ary['WHERE'] .= (($sql_ary['WHERE']) ? ' AND ' : '') . '(' . implode(' OR ', $sql_where) . ')';
		}
	}
	
	if(!sizeof($error) && !empty($sql_ary['WHERE']))
	{
		$keywords_ary_lower = array_map('strtolower', $keywords_ary);

		// Count the posts for pagination
		$count_ary = array(
			'SELECT'	=> 'COUNT(*) AS total',
			'FROM'		=> $sql_ary['FROM'],
			'WHERE'		=> $sql_ary['WHERE'],
		);
		$sql = $db->sql_build_query('SELECT', $count_ary);
		$result = $db->sql_query($sql);
		$total_posts = (int)$db->sql_fetchfield('total');
		$db->sql_freeresult($result);
		
		$sql = $db->sql_build_query('SELECT', $sql_ary);
		$result = $db->sql_query_limit($sql, $config['blog_num_posts'], $start);
		while(sizeof($post_rows) < $config['blog_posts_per_page'] && ($row = $db->sql_fetchrow($result)))
		{
			if($author_id || $tag || check_row_result($keywords_ary_lower, $row['post_title'], $row['post_text']))
			{
				$post_rows[$row['post_id']] = $row;
				
				if($row['post_type'] == POST_TYPE_BBCODE)
				{
					$bbcode_bitfield = $bbcode_bitfield | base64_decode($row['bbcode_bitfield']);
				}
			}
		}
		$db->sql_freeresult($result);
		
		if(sizeof($post_rows))
		{
			// Get all the categories for the posts
			blog::append_post_categories($post_rows);
			
			// Instantiate BBCode if need be
			if ($bbcode_bitfield !== '')
			{
				if(!class_exists('bbcode'))
				{
					include($phpbb_root_path . 'includes/bbcode.' . $phpEx);
				}

				$bbcode = new bbcode(base64_encode($bbcode_bitfield));
			}
		
			foreach($post_rows as $post_id => $row)
			{
				if(!empty($blog_hook->seo))
				{
					$blog_hook->seo->prepare_url('post', $row, 'title');
				}
			
				$row_action	= blog::append_sid('view', $row, false, true);
				
				switch($row['post_type'])
				{
					case POST_TYPE_BBCODE:
						$row['post_text'] = censor_text($row['post_text']);

						// Strip some bbcode tags
						$row['post_text'] = preg_replace('#\[(code|quote|flash)(\:[0-9a-z]{5,})\].*?\[\/\\1\\2\]#is', '', $row['post_text']);
						
						// Second parse bbcode here
						if($row['bbcode_bitfield'])
						{
							$bbcode->bbcode_second_pass($row['post_text'], $row['bbcode_uid'], $row['bbcode_bitfield']);
						}
						
						$row['post_text'] = blog::smiley_text($row['post_text']);
						
						blog::clear_resume_tags($row['post_text']);
					break;
					
					case POST_TYPE_HTML:
						if(!isset($html_message_parser))
						{
							if(!class_exists('html_parse_message'))
							{
								include($blog_hook->root_path . 'includes/html_message_parser.' . $phpEx);
							}
							$html_message_parser = new html_parse_message();
						}

						$html_message_parser->message = $row['post_text'];
						$row['post_text'] = $html_message_parser->format_display(false, true, true);
					break;
				}

				$template->assign_block_vars('postrow', array(
					'S_TITLE'			=> $row['post_title'],
					'S_CONTENT'			=> blog::generate_resume($row),
					'S_HEADER'			=> $user->lang('POST_HEADER', get_username_string('full', $row['poster_id'], $row['username'], $row['user_colour'], $row['post_username']), $user->format_date($row['post_time'], $config['blog_date_format'])),
					'S_CATEGORIES'		=> $user->lang('POST_CATEGORIES', blog::row_categories($row)),
					'U_ACTION'			=> $row_action,
					'UNAPPROVED_IMG'	=> (!$row['post_approved']) ? $user->img('icon_topic_unapproved', 'BLOG_POST_UNAPPROVED') : '',
				));
			}
		}
	}

	$pagination_url = blog::append_sid('search', false, array(
		'tag' 		=> $tag,
		'keywords'	=> (sizeof($keywords_ary) ? urlencode(implode(' ', $keywords_ary)) : ''),
		'author_id'	=> $author_id,
		'terms'		=> $terms,
		'sf'		=> $sf,
	));
	
	if($author_id)
	{
		$page_title = $user->lang('SEARCH_RESULTS_USER', $user_data['username']);
	}
	else
	{
		$page_title = 'SEARCH_RESULTS';
	}

	$s_title = ($tag) ? $user->lang('ARCHIVE_SEARCH_TAG', $tag) : '';
	$s_title = ($keywords) ? $user->lang('ARCHIVE_SEARCH_KW', implode(' ', $keywords_ary)) : $s_title;
	$s_title = ($author_id) ? '<strong>' . $page_title . '</strong>' : $s_title;
	
	$template->assign_vars(array(
		'PAGINATION'	=> generate_pagination($pagination_url, $total_posts, $config['blog_posts_per_page'], $start),
		'PAGE_NUMBER'	=> on_page($total_posts, $config['blog_posts_per_page'], $start),
		'S_ERROR'		=> (sizeof($error) ? implode('<br />', $error) : ''),
		'S_TITLE'		=> $s_title,
	));
}

if((!$tag && !$keywords && !$author_id) || sizeof($error))
{
	// Main page
	$template->assign_vars(array(
		'S_MAIN_PAGE'		=> true,
		'S_KEYWORDS'		=> (sizeof($keywords_ary) ? implode(' ', $keywords_ary) : ''),
	));
	
	$page_title = 'SEARCH';
}

// Output page
$page_title = (isset($user->lang[$page_title]) ? $user->lang[$page_title] : $page_title);
page_header($page_title);

$template->assign_vars(array(
	'S_IN_SEARCH'	=> true,
	'S_ERROR'		=> (sizeof($error) ? implode('<br />', $error) : ''),
));

blog::build_navbar(false, array(
	'SEARCH'	=> array('search')
));

$template->set_filenames(array(
	'body' => 'blog/search_body.html'
));

page_footer(false);

function check_row_result($keywords, $post_title, $post_text)
{
	// Remove BBCodes and HTML to obtain plain text
	$finds = array(
		'#<\/?[^>]+>#',
		"#\[\/?[a-z0-9\*\+\-]+(?:=(?:&quot;.*&quot;|[^\]]*))?(?::[a-z])?(\:[0-9a-z]{5,})\]#"
	);

	$post_title = strtolower($post_title);
	$post_text	= strtolower(preg_replace($finds, '', htmlspecialchars_decode($post_text)));
	
	foreach($keywords as $keyword)
	{
		if(strpos($post_title, $keyword) !== false || strpos($post_text, $keyword) !== false)
		{
			return true;
		}
	}
	
	return false;
}

?>