<?php
/*
*
* @name archive_widget.php
* @package phpBB3 cBB Blog
* @version $Id: archive_widget.php,v1.0.1 10/06/2013 $
*
* @copyright (c) 2013 CaniDev
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
if (!defined('IN_PHPBB'))
{
	exit;
}

class archive_widget
{
	var $options = array();

	function init()
	{
		global $db, $template, $user, $auth, $blog_hook;

		$this->tpl_name = 'archive_widget';
		
		$sql = 'SELECT *
			FROM ' . BLOG_ARCHIVES_TABLE . '
			ORDER BY archive_year DESC, archive_month ASC';
		$result = $db->sql_query($sql);
		while($row = $db->sql_fetchrow($result))
		{
			if(!isset($archives[$row['archive_year']]))
			{
				$archives[$row['archive_year']] = array();
			}
			
			$archives[$row['archive_year']][] = $row;
		}
		$db->sql_freeresult($result);

		// Delete the array in the template if exists, prevent errors between widgets
		$template->destroy_block_vars('archiverow');
		
		foreach($archives as $archive_year => $archive_data)
		{
			$childs = array();
			
			foreach($archive_data as $archive_row)
			{
				$month_name	= $blog_hook->month_names[$archive_row['archive_month']];
				$row_count	= ($auth->acl_get('m_blog_approve') ? $archive_row['post_count_real'] : $archive_row['post_count']);

				if(!$row_count)
				{
					continue;
				}
				
				$childs[] = array(
					'S_TITLE'	=> $user->lang['datetime'][$month_name] . (($this->options['show_post_count']) ? ' (' . $row_count . ')' : ''),
					'U_ACTION'	=> blog::append_sid('index', false, array('a' => $archive_row['archive_month'] . '-' . $archive_row['archive_year'])),
				);
			}
			
			if(sizeof($childs))
			{
				$template->assign_block_vars('archiverow', array(
					'S_LEGEND'		=> $archive_year
				));

				foreach($childs as $child)
				{
					$template->assign_block_vars('archiverow', $child);
				}
			}
		}

		return true;
	}
	
	function get_config()
	{
		$this->display_vars = array(
			'show_post_count'		=> array('lang' => 'BLOG_SHOW_POST_COUNT',		'validate' => 'bool',	'type' => 'radio:yes_no',	'default' => 1),
		);

		return true;
	}
}
?>
