<?php
/*
*
* @name recent_comments_widget.php
* @package phpBB3 cBB Blog
* @version $Id: recent_comments_widget.php,v1.0.1 10/06/2013 $
*
* @copyright (c) 2013 CaniDev
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
if (!defined('IN_PHPBB'))
{
	exit;
}

class recent_comments_widget
{
	var $options = array();

	function init()
	{
		global $db, $template, $user, $auth;
		global $blog_hook;
		
		$cmntrow = $postrow = array();

		$this->tpl_name = 'recent_comments_widget';
		
		// Delete the array in the template if exists, prevent errors between widgets
		$template->destroy_block_vars('wcmntrow');
		
		$sql = 'SELECT c.comment_id, c.post_id, c.user_id, c.username, p.post_title, p.post_url,
			u.username AS member_name, u.user_colour
			FROM ' . BLOG_COMMENTS_TABLE . ' c
				LEFT JOIN ' . BLOG_POSTS_TABLE . ' p ON(p.post_id = c.post_id)
				LEFT JOIN ' . USERS_TABLE . ' u ON(u.user_id = c.user_id)
			ORDER BY comment_time DESC';
		$result = $db->sql_query_limit($sql, $this->options['comment_num']);
		while($row = $db->sql_fetchrow($result))
		{
			$post_id = (int)$row['post_id'];
			$cmntrow[] = $row;
			
			$postrow[$post_id] = array(
				'post_id'	=> $post_id
			);
		}
		$db->sql_freeresult($result);
		
		if(sizeof($cmntrow))
		{
			blog::append_post_categories($postrow);
			
			foreach($cmntrow as $row)
			{
				$post_id = (int)$row['post_id'];
				
				if($row['user_id'] != ANONYMOUS)
				{
					$row['username'] = $row['member_name'];
				}
				
				if(!empty($blog_hook->seo))
				{
					$blog_hook->seo->prepare_url('post', $row, 'title');
				}
				
				$template->assign_block_vars('wcmntrow', array(
					'ID'			=> $row['comment_id'],
					'S_AUTHOR'		=> get_username_string('full', $row['user_id'], $row['username'], $row['user_colour']),
					'S_POST_TITLE'	=> $row['post_title'],
					'U_POST_TITLE'	=> blog::append_sid('view', $postrow[$post_id], false, true),
				));
			}
		}
		
		return true;
	}
	
	function get_config()
	{
		$this->display_vars = array(
			'comment_num'		=> array('lang' => 'BLOG_COMMENT_NUM',		'validate' => 'int:0:50',	'type' => 'text:4:3',	'default' => 5),
		);

		return true;
	}
}
?>
