<?php
/*
*
* @name recent_entries_widget.php
* @package phpBB3 cBB Blog
* @version $Id: recent_entries_widget.php,v1.0.1 10/06/2013 $
*
* @copyright (c) 2013 CaniDev
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
if (!defined('IN_PHPBB'))
{
	exit;
}

class recent_entries_widget
{
	var $options = array();

	function init()
	{
		global $db, $template, $user, $auth;
		global $blog_hook;
		
		$postrow = array();

		$this->tpl_name = 'recent_entries_widget';
		
		// Delete the array in the template if exists, prevent errors between widgets
		$template->destroy_block_vars('wpostrow');
		
		$sql_where = 'WHERE p.post_time < ' . time();
		
		if(!$auth->acl_get('m_blog_approve'))
		{
			$sql_where .= ' AND p.post_approved = 1';
		}
		
		$sql = 'SELECT p.post_id, p.post_title, p.post_url
			FROM ' . BLOG_POSTS_TABLE . ' p
				LEFT JOIN ' . BLOG_POSTS_TRACK_TABLE . " pt ON(pt.post_id = p.post_id)
			$sql_where
			AND pt.cat_id IS NOT NULL
			ORDER BY p.post_time DESC";
		$result = $db->sql_query_limit($sql, $this->options['post_num']);
		while($row = $db->sql_fetchrow($result))
		{
			$post_id = (int)$row['post_id'];
			$postrow[$post_id] = $row;
		}
		$db->sql_freeresult($result);
		
		if(sizeof($postrow))
		{
			blog::append_post_categories($postrow);
			
			foreach($postrow as $row)
			{
				if(!empty($blog_hook->seo))
				{
					$blog_hook->seo->prepare_url('post', $row, 'title');
				}

				$template->assign_block_vars('wpostrow', array(
					'MINI_POST_IMG'		=> $user->img('icon_post_target', 'POST'),
					'S_TITLE'			=> $row['post_title'],
					'U_TITLE'			=> blog::append_sid('view', $row, false, true),
				));
			}
		}
		
		return true;
	}
	
	function get_config()
	{
		$this->display_vars = array(
			'post_num'		=> array('lang' => 'BLOG_POST_NUM',		'validate' => 'int:0:50',	'type' => 'text:4:3',	'default' => 5),
		);

		return true;
	}
}
?>
