<?php
/*
*
* @name rss_widget.php
* @package phpBB3 cBB Blog
* @version $Id: rss_widget.php,v1.0.1 10/06/2013 $
*
* @copyright (c) 2013 CaniDev
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
if (!defined('IN_PHPBB'))
{
	exit;
}

class rss_widget
{
	var $options = array();

	function init()
	{
		global $template, $user;

		$this->tpl_name = 'rss_widget';
		
		$links = array(
			'RSS_POSTS'		=> array('mode' => 'posts'),
			'RSS_COMMENTS'	=> array('mode' => 'comments'),
		);
		
		$cat_id = request_var('c', 0);
		
		if($cat_data = blog::get_category($cat_id))
		{
			$links['sep1'] = '';

			$s1 = $user->lang('RSS_CAT_POSTS', $cat_data['cat_name']);
			$s2 = $user->lang('RSS_CAT_COMMENTS', $cat_data['cat_name']);

			$links[$s1] = array(
				'mode'	=> 'posts',
				'c'		=> $cat_data['cat_id'],
			);
			
			$links[$s2] = array(
				'mode'	=> 'comments',
				'c'		=> $cat_data['cat_id'],
			);
		}
		
		// Delete the array in the template if exists, prevent errors between widgets
		$template->destroy_block_vars('linkrow');
		
		foreach($links as $link_name => $link_params)
		{
			if(strpos($link_name, 'sep') !== false)
			{
				$template->assign_block_vars('linkrow', array(
					'IS_SEPARATOR'	=> true,
				));

				continue;
			}
			
			$template->assign_block_vars('linkrow', array(
				'S_TITLE'	=> (isset($user->lang[$link_name]) ? $user->lang[$link_name] : $link_name),
				'U_ACTION'	=> blog::append_sid('rss', false, $link_params),
			));
		}

		return true;
	}
	
	function get_config()
	{
		return false;
	}
}
?>
