<?php
/*
*
* @name tags_widget.php
* @package phpBB3 cBB Blog
* @version $Id: cloud_tag_block.php,v1.0.1 10/06/2013 $
*
* @copyright (c) 2013 CaniDev
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
if (!defined('IN_PHPBB'))
{
	exit;
}

class tags_widget
{
	function init()
	{
		global $phpbb_root_path, $template, $db, $user, $phpEx;

		$this->tpl_name = 'tags_widget';
		
		$has_tags = false;
		
		$sql = 'SELECT COUNT(*) AS tag_count, tag_name
			FROM ' . BLOG_TAGS_TABLE . '
			GROUP BY tag_name
			ORDER BY tag_count';
		$result = $db->sql_query_limit($sql, $this->options['max_words']);
		while($row = $db->sql_fetchrow($result))
		{
			$tag_size = ($this->options['animation']) ?  rand(10, 16) : rand(8, 22);

			$template->assign_block_vars('clouds', array(
				'S_TAG_NAME'	=> $row['tag_name'],
				'S_TAG_SIZE'	=> $tag_size,
				'U_TAG_URL'		=> blog::append_sid('search', false, array(
					'tag'	=> urlencode(strtolower($row['tag_name']))
				)),
			));
			
			$has_tags = true;
		}
		$db->sql_freeresult($result);

		$template->assign_var('S_SHOW_ANIMATION', $this->options['animation']);

		return $has_tags;
	}

	function get_config()
	{
		$this->display_vars = array(
			'animation'		=> array('lang' => 'CLOUD_ANIMATION',	'validate' => 'bool',		'type' => 'radio:yes_no', 	'default' => 1),
			'max_words'		=> array('lang' => 'CLOUD_WORDS',		'validate' => 'int:1:50',	'type' => 'text:4:3', 		'default' => 25),
		);

		return true;
	}
}
?>
